



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>selenium处理iframe定位于切换问题解决办法</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">selenium处理iframe定位于切换问题解决办法</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-08 22:22:24 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h3>首先还是围绕以下几个方面来看：</h3>
<p>1.什么是iframe？</p>
<p>2.为什么我们要定位iframe？</p>
<p>3.我们怎样定位iframe，与切换iframe？</p>
<h3>1.什么是iframe？</h3>
<p>&diams; b/s架构都使用iframe，官方的定义是这样的：【iframe 元素会创建包含另外一个文档的内联框架（即行内框架）】。什么意思呢，就像是我们的某个主页，里面有好多小模块，每&nbsp; &nbsp; &nbsp; 个 小模块用这个叫做iframe的东西分开来，方便维护，也方便开发各自开发各自的部分，互不相干。</p>
<p>&diams;&nbsp;通常不在同一个iframe分为两种情况：一种是包含，一种是平级。</p>
<h3>2.为什么我们要定位iframe？</h3>
<p>&diams; 介于iframe是独立开的一个一个的小模块，就像是船舱的特性，所以iframe就行船舱的舱门，想要进入船舱去找东西，就必须先进入舱门，所以当元素在不同的iframe时，就必须先进入到元素所在地的iframe之后才能定位到元素。</p>
<h3>3.我们怎样定位iframe，与切换iframe？</h3>
<p>&diams; iframe几种情况：1.包含关系也就是嵌套 。2.平级关系</p>
<h4>　　3.1.定位iframe几种方式：1.用iframe中的ID来定位 2.用iframe中的name来定位 3.用xpath来定位 4.用css来定位</h4>
<p><img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/1401386/201805/1401386-20180525100934852-1331925624.png" /></p>
<p>&diams; 首先我们用self.driver.switch_to.frame()这个方法来进入iframe框架，如果iframe是包含关系，需要从最外面的iframe一层一层进入。</p>
<div>
<pre class="prettyprint linenums">self.driver.switch_to.frame()</pre>
</div>
<p>&diams;1.用iframe中的ID来定位</p>
<div>
<pre class="prettyprint linenums">self.driver.switch_to.frame('noticeCheckWin')</pre>
</div>
<p>&diams;2.用iframe中的name来定位</p>
<div>
<pre class="prettyprint linenums">self.driver.switch_to.frame('noticeCheckWin')</pre>
</div>
<p>&diams;3.用xpath来定位</p>
<div>
<pre class="prettyprint linenums"> self.frame2 = self.driver.find_element_by_xpath('/html/body/div[2]/div[2]/div[2]/iframe[3]')

 self.driver.switch_to.frame(self.frame2)#定位动态的iframe，可以把动态的部分删了然后再用xpath定位</pre>
</div>
<p>&diams;4.用css来定位</p>
<div>
<pre class="prettyprint linenums">self.frame3 = self.driver.find_element_by_css_selector('body &gt; div.h-main &gt; div.h-screen.layout &gt; div.h-screen-con &gt; iframe')#也可以查出所有的路径用下标切出来<br />
self.driver.switch_to.frame(self.frame3)</pre>
</div>
<h4>3.2.退出iframe</h4>
<p>&diams; 退出iframe有两种形式：1.退出所有的iframe切换到主文档 2.退回到父级iframe</p>
<p>&diams;1.退出所有的iframe切换到主文档</p>
<div>
<pre class="prettyprint linenums">self.driver.switch_to.default_content()</pre>
</div>
<p>&diams;2.退回到父级iframe</p>
<div>
<pre class="prettyprint linenums">switch to.parent_frame()#退回到自己想要的层级</pre>
</div>
<h4>4.场景：1.包含关系也就是嵌套 。2.平级关系</h4>
<p>&diams;&nbsp;包含关系也就是嵌套 ，一个iframe的层次在另一个iframe之下。</p>
<p>&diams; 4.1.switch to.parent_frame()#退回到自己想要的层级</p>
<div>
<pre class="prettyprint linenums">self.driver.switch_to.frame('noticeCheckWin')#进入一个iframe。<br />
time.sleep(10)<br />
self.driver.find_element_by_id('startProcess').click()#进入发起流程<br />
time.sleep(10)<br />
self.frame2=self.driver.find_element_by_xpath('/html/body/div[2]/div[2]/div[2]/iframe[3]')<br />
self.driver.switch_to.frame(self.frame2)#进入第二个iframe<br />
time.sleep(10)<br />
self.driver.find_element_by_id('startProcess').click()#定位元素<br />
self.driver.switch to.parent_frame()#退出第二个iframe<br />
self.driver.find_element_by_id('account_pass').send_keys('')#在第一个框架内定位元素<br />
self.driver.switch to.parent_frame()#退出第一个iframe</pre>
</div>
<p>&diams;1.退出所有的iframe切换到主文档</p>
<div>
<pre class="prettyprint linenums">self.driver.switch_to.frame('noticeCheckWin')#进入一个iframe。<br />
time.sleep(10)<br />
self.driver.find_element_by_id('startProcess').click()#进入发起流程<br />
time.sleep(10)<br />
self.frame2=self.driver.find_element_by_xpath('/html/body/div[2]/div[2]/div[2]/iframe[3]')<br />
self.driver.switch_to.frame(self.frame2)#进入第二个iframe<br />
time.sleep(10)<br />
self.driver.find_element_by_id('startProcess').click()#定位元素<br />
self.driver.switch_to.default_content()#直接退出第一个iframe</pre>
</div>
<p>注意：在遇到动态的ID或者name时我们直接把动态ID或者name删掉重新copy，xpath或者，css就行。如图：</p>
<p><img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/1401386/201805/1401386-20180525111021013-253744312.png" /></p>
<p>有什么需要补充的或者说的不对的地方请一定要指正出来，谢谢啦。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/49g71je9.html">bootstrap-列表组</a>
		</li>
						<li><a href="https://www.batexi.com/a/qderorz9.html">【HDOJ】4322 Candy</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxkyngz8.html">【Android Developers Training】 14&period; 序言：管理Activity生命周期</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ey2gxk9.html">Array&period;prototype鲜为人知的事实</a>
		</li>
						<li><a href="https://www.batexi.com/a/90m575n8.html">【BZOJ4003】【JLOI2015】城池攻占</a>
		</li>
						<li><a href="https://www.batexi.com/a/90m5woo8.html">【翻译】如何创建Ext JS暗黑主题之二</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy1jm6gq.html">RedHat Linux下iptables防火墙设置</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jz3xv8.html">&lbrack;转载&rsqb; Java中枚举类型的使用 - enum</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1k70r29.html">【Golang笔记】Golang工具包Cobra安装记录</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy1k7wdq.html">sql笔试题</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwj3klk8.html">第三周四则运算辅助&lpar;CAI&rpar;结对项目需求文档</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pd1x7y9.html">&lbrack;SDOI2009&rsqb;SuperGCD</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zyokwd9.html">jquery调用iframe里面的方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zy3nwn9.html">EPOCH batchsize</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7o23ng8.html">tree-lstm初探</a>
		</li>
						<li><a href="https://www.batexi.com/a/qllp5l1q.html">Zabbix告警脚本-短信</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gjw2v79.html">查看hp小型机命令集</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rnz0oeq.html">HDU 1269 迷宫城堡（判断有向图强连通分量的个数，tarjan算法）</a>
		</li>
						<li><a href="https://www.batexi.com/a/902vve4q.html">UVA - 10129 Play on Words （欧拉回路&plus;并查集）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8konx56q.html">TTFB</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qwjmzgk8.html">&rsqb;Java 5&vert;6 并发包介绍</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlj32d09.html">Ubuntu硬盘空间清理</a>
			</li>
						<li><a href="https://www.batexi.com/a/950kll08.html">git push The requested URL returned error&colon; 403 Forbidden while accessing</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdp4v0vq.html">Java并发-容器</a>
			</li>
						<li><a href="https://www.batexi.com/a/90mx5lo8.html">Node笔记五-进程、线程</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1k66nz9.html">ArcCore重构-Platform&lowbar;Types&period;h实现辨析</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv1mykzq.html">Flask入门之Jinjia模板的一些语法</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kpg7vj9.html">Vue中的scoped及穿透方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/90mxgpn8.html">小隐隐于野：基于TCP反射DDoS攻击分析</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4zvlz09.html">Spring Boot实战笔记（四）-- Spring常用配置（事件Application Event）</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
